import 'dart:async';

import 'package:flutter/services.dart';

class PagseguroPlugin {
  static const MethodChannel _channel =
      const MethodChannel('pagseguroplugin');

  Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  Future<bool> initialize({String appVersion, String appName, String activationCode}) async {
    final dynamic result = await _channel.invokeMapMethod('initialize', {
      'appName': appName,
      'appVersion': appVersion,
      'activationCode': activationCode
    });
    return result;
  }

  Future<bool> startPayment({
    num amount,
    int installments,
    String type
  }) async {
    await _channel.invokeMapMethod('startPayment', {
      'amount': amount,
      'installments': installments,
      'type': type
    });
    return true;
  }
}